function U = DeePC_OSQP_1norm(N,Tini,T, UP, YP, UF,YF,lambda_g,x_ini,t,lambda_y, Q, R,r,ub,lb)
% This function will solve the DeePC optimization problem (1-norm regularization) by using OSQP.

m = 2;
p = 2;

Hc = T-Tini-N+1;

global osqpSolver;   

if t == 0
    % We initialize the sovler at t = 0.
    H = blkdiag([UF]'*R * [UF] + (YF'*Q * YF), lambda_y * eye(p*Tini), 0*eye(Hc,Hc));
    f = [- kron(r',ones(1,N)) * Q * YF      zeros(1,p*Tini)      0.5 * lambda_g * ones(1,Hc)];
    Aeq = [[UP;YP] [zeros(m*Tini,p*Tini);-1 * eye(p*Tini)] zeros(m*Tini+p*Tini,Hc)];
    Aineq = [ [UF;YF; eye(Hc); eye(Hc)]   zeros(m*N + p*N + 2*Hc,p*Tini) [ zeros(m*N + p*N,Hc); - eye(Hc); eye(Hc) ] ];
    
    l = [x_ini;kron(lb,ones(N,1)); -1e20*ones(Hc,1); zeros(Hc,1)   ];
    u = [x_ini;kron(ub,ones(N,1)); zeros(Hc,1);     1e20*ones(Hc,1)];
    
    osqpSolver = osqp;
    osqpSolver.setup(H,f,[Aeq;Aineq],l,u);
    
    out = osqpSolver.solve();
    g = out.x;
    U = [UF] * g(1:Hc,1);
else
    l = [x_ini;kron(lb,ones(N,1)); -1e20*ones(Hc,1); zeros(Hc,1)   ];
    u = [x_ini;kron(ub,ones(N,1)); zeros(Hc,1);     1e20*ones(Hc,1)];
    f = [- kron(r',ones(1,N)) * Q * YF      zeros(1,p*Tini)      0.5 * lambda_g * ones(1,Hc)];
    osqpSolver.update('l', l, 'u', u, 'q', f);
    out = osqpSolver.solve();
    g = out.x;
    U = [UF] * g(1:Hc,1);
end
    
end

